﻿using System;
using System.Windows.Forms;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Text;
using System.IO;

namespace AutoInput
{
    public partial class Main : Form
    {
        private delegate bool EnumThreadDelegate(IntPtr hWnd, IntPtr lParam);
        [DllImport("user32")] private static extern bool SendMessage(IntPtr hWnd, UInt32 Msg, IntPtr wParam, IntPtr lParam);
        [DllImport("user32")] private static extern bool EnumThreadWindows(int dwThreadId, EnumThreadDelegate lpfn, IntPtr lParam);
        [DllImport("user32", CharSet = CharSet.Auto)] private static extern bool GetClassName(IntPtr hWnd, StringBuilder lpClassName, int nMaxCount);
        [DllImport("user32")] private static extern bool SetForegroundWindow(IntPtr hWnd);
        private string Dir;
        private int Time;
        private float Sleep;
        private float Wait;
        private string Carton = "Teemo";
        private bool Enable;

        public Main()
        {
            InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false;
            LoadConfig();
            Reader.Enabled = true;
        }

        private void Teemo_Tick(object sender, EventArgs e)
        {
            if (Wait > 100)
            {
                Wait -= 100;
                return;
            }
            Process[] processes = Process.GetProcesses();
            foreach (Process process in processes)
            {
                if (process.MainWindowTitle.Contains("MES"))
                {
                    SetForegroundWindow(process.MainWindowHandle);
                    for (int i = 0; i < Time; ++i)
                    {
                        SendKeys.Send(Carton);
                        SendKeys.Send("{ENTER}");
                    }
                    Process[] packing = Process.GetProcessesByName("Packing");
                    if (packing.Length > 0) SetForegroundWindow(packing[0].MainWindowHandle);
                    break;
                }
            }
            Teemo.Enabled = false;
        }

        private void Main_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Space)
            {
                Enable = !Enable;
                Switcher.ForeColor = Enable ? System.Drawing.Color.Lime : System.Drawing.Color.Gray;
            }
        }

        private void Reader_Tick(object sender, EventArgs e)
        {
            if (Enable)
            {
                Closer();
                DateTime now = DateTime.Now;
                string path = Dir + "\\log-" + now.Year + ((now.Month < 10) ? "0" : "") + now.Month + ((now.Day < 10) ? "0" : "") + now.Day + ".txt";
                try
                {
                    FileStream fileStream = new FileStream(path, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
                    if (fileStream.Length >= 32768) fileStream.Seek(-16384, SeekOrigin.End);
                    StreamReader streamReader = new StreamReader(fileStream);
                    streamReader.ReadLine();
                    string ctn = "Teemo";
                    while (!streamReader.EndOfStream)
                    {
                        string line = streamReader.ReadLine();
                        if (line.Contains(" [INF] In th"))
                        {
                            float time = float.Parse(line.Substring(17, 6));
                            float tnow = float.Parse(now.Second + "." + now.Millisecond);
                            Wait = Sleep - Math.Abs(tnow - time) * 1000;
                            string cid = line.Substring(line.LastIndexOf(" ") + 1);
                            if (cid.StartsWith("C") && !cid.Equals(ctn)) ctn = cid;
                        }
                    }
                    if (!ctn.Equals("Teemo") && !Carton.Equals(ctn))
                    {
                        Carton = ctn;
                        Teemo.Enabled = true;
                    }
                }
                catch
                {
                    Enable = false;
                    Switcher.ForeColor = System.Drawing.Color.Gray;
                    MessageBox.Show("Lỗi trong quá trình đọc dữ liệu!");
                }
            }
        }

        private bool CloseDialog(IntPtr hWnd, IntPtr lParam)
        {
            StringBuilder sb = new StringBuilder(256);
            GetClassName(hWnd, sb, sb.Capacity);
            if (sb.ToString() != "#32770") return false;
            SendMessage(hWnd, 0x0010, IntPtr.Zero, IntPtr.Zero);
            return true;
        }

        private void Closer()
        {
            Process[] processes = Process.GetProcessesByName("Packing");
            if (processes.Length > 0)
            {
                foreach (ProcessThread pt in processes[0].Threads)
                {
                    EnumThreadWindows(pt.Id, new EnumThreadDelegate(CloseDialog), IntPtr.Zero);
                }
            }
        }

        private void LoadConfig()
        {
            string[] data = File.ReadAllText("Config").Split('|');
            Dir = data[0];
            Time = int.Parse(data[1]);
            Sleep = float.Parse(data[2]);
            Directory.Text = Dir;
            SleepTime.Text = Sleep.ToString();
            switch (Time)
            {
                case 1:
                    Time1.Checked = true;
                    break;
                case 2:
                    Time2.Checked = true;
                    break;
                case 3:
                    Time3.Checked = true;
                    break;
            }
        }

        private void SaveConfig()
        {
            File.WriteAllText("Config", Dir + "|" + Time + "|" + Sleep);
        }

        private void Notify_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                Notify.Visible = false;
                this.Show();
                this.WindowState = FormWindowState.Normal;
            }
        }

        private void Main_Resize(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                Notify.Visible = true;
                this.Hide();
                if (Enable) Notify.ShowBalloonTip(1000);
            }
        }

        private void Time1_Click(object sender, EventArgs e)
        {
            Time = 1;
            Time1.Checked = true;
            Time2.Checked = false;
            Time3.Checked = false;
            SaveConfig();
        }

        private void Time2_Click(object sender, EventArgs e)
        {
            Time = 2;
            Time2.Checked = true;
            Time1.Checked = false;
            Time3.Checked = false;
            SaveConfig();
        }

        private void Time3_Click(object sender, EventArgs e)
        {
            Time = 3;
            Time3.Checked = true;
            Time1.Checked = false;
            Time2.Checked = false;
            SaveConfig();
        }

        private void Directory_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                Dir = Directory.Text;
                Directory.SelectAll();
                SaveConfig();
            }
        }

        private void SleepTime_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!char.IsControl(e.KeyChar) && !char.IsDigit(e.KeyChar))
            {
                e.Handled = true;
            }
            if (e.KeyChar == (char)Keys.Enter)
            {
                Sleep = float.Parse(SleepTime.Text);
                SleepTime.SelectAll();
                SaveConfig();
            }
        }
    }
}
